Ruby: include/ruby/internal/newobj.h File Reference

Ruby 3.4.7p58 (2025-10-08 revision 7a5688e2a27668e48f8d6ff4af5b2208b98a2f5e)

Macros | Functions
newobj.h File Reference

Defines #NEWOBJ. More...

`#include "ruby/internal/attr/deprecated.h"`
`#include "ruby/internal/cast.h"`
`#include "ruby/internal/core/rbasic.h"`
`#include "ruby/internal/dllexport.h"`
`#include "ruby/internal/fl_type.h"`
`#include "ruby/internal/special_consts.h"`
`#include "ruby/internal/value.h"`
`#include "ruby/assert.h"`

Go to the source code of this file.

## Macros
#define | OBJSETUP rb_obj_setup
| Old name of rb_obj_setup.
#define | CLONESETUP rb_clone_setup
| Old name of rb_clone_setup.
#define | DUPSETUP rb_dup_setup
| Old name of rb_dup_setup.

## Functions
VALUE | rb_obj_setup (VALUE obj, VALUE klass, VALUE type)
| Fills common fields in the object.
VALUE | rb_obj_class (VALUE obj)
| Queries the class of an object.
VALUE | rb_singleton_class_clone (VALUE obj)
| Clones a singleton class.
void | rb_singleton_class_attached (VALUE klass, VALUE obj)
| Attaches a singleton class to its corresponding object.
void | rb_copy_generic_ivar (VALUE clone, VALUE obj)
| Copies the list of instance variables.
static void | rb_clone_setup (VALUE clone, VALUE obj)
static void | rb_dup_setup (VALUE dup, VALUE obj)

## Detailed Description

Defines #NEWOBJ.

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either RBIMPL or rbimpl are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance __VA_ARGS__ is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file newobj.h.

## Function Documentation

## ◆ rb_clone_setup()

void rb_clone_setup | ( | VALUE | clone,
|  | VALUE | obj )
| inlinestatic

Deprecated
  Not sure exactly when but at some time, the implementation of Object#clone stopped using this function. It remained untouched for a while, and then @shyouhei realised that they are no longer doing the same thing. It seems nobody seriously uses this function any longer. Let's just abandon it.

Parameters

  [out] | clone | The destination object.
  [in] | obj | The source object.

Definition at line 124 of file newobj.h.

Referenced by rb_clone_setup().

## ◆ rb_copy_generic_ivar()

void rb_copy_generic_ivar | ( | VALUE | clone,
|  | VALUE | obj )

Copies the list of instance variables.

3rd parties need not know, but there are several ways to store an object's instance variables, depending on its internal structure. This function makes sense when either of the passed objects are using so-called "generic" backend storage. This distinction is purely an implementation detail of rb_clone_setup(). People need not be aware of this working behind-the-scenes.

Parameters

  [out] | clone | The destination object.
  [in] | obj | The source object.

Definition at line 2116 of file variable.c.

Referenced by rb_copy_generic_ivar(), and rb_hash_dup().

## ◆ rb_dup_setup()

void rb_dup_setup | ( | VALUE | dup,
|  | VALUE | obj )
| inlinestatic

Deprecated
  Not sure exactly when but at some time, the implementation of Object#dup stopped using this function. It remained untouched for a while, and then @shyouhei realised that they are no longer the same thing. It seems nobody seriously uses this function any longer. Let's just abandon it.

Parameters

  [out] | dup | The destination object.
  [in] | obj | The source object.

Definition at line 143 of file newobj.h.

Referenced by rb_dup_setup().